﻿# Créé par zhang, le 28/02/2014 en Python 3.2

from tkinter import*   #import module tkinter interface graphique
from math import*      #import module maths

#-----------------------les tableaux à doubles entrées--------------------------


start=[[8,0,0,0,0,0,0,0,0], # tableau à double entrée correspondant à l'énoncé du sudoku
       [0,0,3,6,0,0,0,0,0],
       [0,7,0,0,9,0,2,0,0],
       [0,5,0,0,0,7,0,0,0],
       [0,0,0,0,4,5,7,0,0],
       [0,0,0,1,0,0,0,3,0],
       [0,0,1,0,0,0,0,6,8],
       [0,0,8,5,0,0,0,1,0],
       [0,9,0,0,0,0,4,0,0]]



s=[[0,0,0,0,0,0,0,0,0],#tableau à double entrée correspondant à la solution finale, qui sera compléter et vérifier au fur à mesure
   [0,0,0,0,0,0,0,0,0],
   [0,0,0,0,0,0,0,0,0],
   [0,0,0,0,0,0,0,0,0],
   [0,0,0,0,0,0,0,0,0],
   [0,0,0,0,0,0,0,0,0],
   [0,0,0,0,0,0,0,0,0],
   [0,0,0,0,0,0,0,0,0],
   [0,0,0,0,0,0,0,0,0]]



#-------partie algorithmique permettant de résoudre la grille de sudoku---------



def init(s): # imprimer le tableau à double entrée s
    for i in range(0,9):# imprirer les 9 lignes du tableau
        print (s[i])
    return


def verification9(s):# vérifier si un même chiffre n'apparaîent qu'une seule fois
    result=[0,0,0,0,0,0,0,0,0,0]# initialisation à 0
    #print s
    for i in range(0,9):
        result[s[i]] +=1 #indiquer le nombre de fois d'apparition d'un même chiffre dans les indices correspondants
    for j in range(1,10):
        if result[j]>1: # si le nombre de fois d'appartion d'un même chiffreest plus qu'une fois
            return False # retourne faux
    return True


def block(s,i):# fonction permettant de délimiter des sous tableaux à double entrée 3x3(block)
    t=[0,0,0,0,0,0,0,0,0] # initialisation à 0
    for j in range(0,3):# tableau à double entrée 3x3
        for k in range(0,3):
            t[j*3+k]=s[(i//3)*3+j][(i%3)*3+k]# calculer les coordonnées des cases du tableau, et enregistrer les valeurs du tableau "s" dans "t"
    return t


def veriduSudoku(s):#fonction permettant de vérifier les résultats
    #vérifier ligne par ligne
    t=[0,0,0,0,0,0,0,0,0]
    for i in range(0,9):
        if not verification9(s[i]): #appel à la foncion "verification9"
            # si la fonction "verification9" est fausse, alors il existe des erreurs dans la ligne.
            return False #sortir de ce boucle.
    #vérifier colonne par colonne
    for i in range(0,9):
        for j in range(0,9):
            t[j]=s[j][i] #pour chercher dans les colonnes.
        if not verification9(t):# si la fonction "verification9" est fausse, alors il existe des erreurs dans la colonne.
            return False
    #vérifier block par block
    for i in range(0,9):
        t=block(s,i)
        if not verification9(t):# si la fonction "verification9" est fausse, alors il existe des erreurs dans le block .
            return False
    return True


def chercher(s,case):# fonction principale permettant de résoudre et vérifier le sudoku
    #imprimer les cases déja completées
    if veriduSudoku(s):#appeler "veridusudoku"
        if case==81 :# si les 81 cases sont tous vérifiées
            init(s)# imprimer le problème du sudoku à résoudre
            return True
        else:
            if(start[case//9][case%9]!=0): # Si la valeur dans les coordonnées correspondant du tableau "start" =/= 0
                s[case//9][case%9]=start[case//9][case%9] # copier ce valeur dans les coordonnées correspondant du tableau de "s"
                return chercher(s,case+1)
            else: # Si la valeur dans les coordonnées correspondant du tableau "start" = 0
                for i in range(1,10):
                    s[case//9][case%9]=i #le valeur dans les coordonnées correspondant du tableau de "s" est i (1 à 9)
                    if chercher(s,case+1): #récursivisité
                        return True
                    else:
                        s[case//9][case%9]=0
    else:
        return False


init(start)# utilisation de la fonction init pour imprimer start
print ("searching...")# imprimer "searching"
chercher(s,0)# utilisation de la fonction chercher



#---------------------partie tkinter: interface graphique-----------------------


# variables globales:
x=50
y=50 # coordonnées du sommet haut gauche du tableau qui sera affiché dans le canevas
n=9 # taille du tableau
taille=50 # taille d'une case du tableau


def affiche1(): # affiche le tableau start dans le canevas et les valeurs de ce qu'il contient et création grille
    c1.delete(ALL)
    for i in range(n):# création tableau double entrées
        for j in range(n):
          c1.create_rectangle(x+taille*i,y+taille*j,x+taille*(i+1),y+taille*(j+1),outline='black')# création grille à partir des rectangles
          c1.create_text(x+taille*i+taille/2,y+taille*j+taille/2,font="Arial 10 bold ",text=start[i][j])# afficher start dans le canevas1
          c1.create_line(200,50, 200,500,  width=2,fill="black") #création des lignes en gras
          c1.create_line(350,50, 350,500,  width=2,fill="black")
          c1.create_line(50,200, 500,200,  width=2,fill="black")
          c1.create_line(50,350, 500,350,  width=2,fill="black")
          c1.create_line(50,50, 500,50,  width=2,fill="black")
          c1.create_line(50,50, 50,500,  width=2,fill="black")
          c1.create_line(500,50, 500,500,  width=2,fill="black")
          c1.create_line(50,500, 500,500,  width=2,fill="black")
          c1.create_text(275,30,font="Arial 12  ",text="ENONCE") #création du texte indiquant le sous titre



def affiche2(): # affiche le tableau s dans le canevas et les valeurs de ce qu'il contient et création grille
    c2.delete(ALL)
    for i in range(n): # création tableau double entrées
        for j in range(n):
          c2.create_rectangle(x+taille*i,y+taille*j,x+taille*(i+1),y+taille*(j+1),outline='black',)# création grille à partir des rectangles
          c2.create_text(x+taille*i+taille/2,y+taille*j+taille/2,font="Arial 10 bold ",text=s[i][j])# afficher s dans le canevas2
          c2.create_line(200,50, 200,500,  width=2,fill="black") #création des lignes en gras
          c2.create_line(350,50, 350,500,  width=2,fill="black")
          c2.create_line(50,200, 500,200,  width=2,fill="black")
          c2.create_line(50,350, 500,350,  width=2,fill="black")
          c2.create_line(50,50, 500,50,  width=2,fill="black")
          c2.create_line(50,50, 50,500,  width=2,fill="black")
          c2.create_line(500,50, 500,500,  width=2,fill="black")
          c2.create_line(50,500, 500,500,  width=2,fill="black")
          c2.create_text(275,30,font="Arial 12  ",text="SOLUTION")#création du texte indiquant le sous titre






#------------------------------Programme tkinter--------------------------------

# définir la fenêtre,Création du widget principal
f=Tk()

# création des widgets "esclaves" :
etiquette = Label (f, text = "SUDOKU 数独", fg = "red",padx = 10, pady = 5,font="Arial 18 bold ")# définir l'étiquette (Label) affichant le titre
etiquette.pack(padx = 10, pady = 5)# afficher l'étiquette (Label)

c1=Canvas(f,height=550,width=550,bg='white')# Création d'un widget Canvas (zone graphique)c1
affiche1()# appel à la fonction affiche1
c1.pack(side= "left")# positioner le canvas c1 à gauche

c2=Canvas(f,height=550,width=550,bg="white")# Création d'un widget Canvas (zone graphique)c1
c2.pack(side= "right")# positioner le canvas c2 à gauche
affiche2()# appel à la fonction affiche2

b=Button(f,text="Quitter",command=f.quit) # on pourrait mettre simplement destroy() ce qui éviterait de le mettre après mainloop()
b.pack(side="bottom",padx = 10, pady = 5)# positioner le bouton en bas

f.mainloop()# démarrage du réceptionnaire d'événements
f.destroy()# destruction (fermeture) de la fenêtre
